<template lang="pug">

mixin Param
  Param.col-12.col-sm-6.col-lg-4.col-xl-2&attributes(attributes)

mixin ParamList
  ParamList.col-12.col-sm-6.col-lg-4.col-xl-2&attributes(attributes)

mixin ParamReadonly
  ParamReadonly.col-12.col-sm-6.col-lg-4.col-xl-2&attributes(attributes)

.row.no-gutters
  .col-12
    Collapsible(:class="{ 'text-muted': !(inEdit ? edit.enabled : enabled) }")
      template(v-slot:header)
        .row
          .col-6.col-md-3
            .row.no-gutters
              BaseToggle.col-auto(@click.native.stop :value='enabled' @edit='edit.enabled = $event' :inEdit='inEdit')
              .col-auto #[strong CHANNEL{{channel}}]
          .col-6(v-if="isLoading") #[i.fa.fa-spinner.fa-pulse]
          .col-6(v-else) {{detectorType}}

      .col-12
        Collapsible.x-acq(:expand='true')
          template(v-slot:header)
            strong Acquisition
          .col-12
            .row.b-param-container
              +Param(ref="detectorType" title="Detector Name" :value="detectorType"
                @edit='edit.detectorType = $event' :inEdit="inEdit" maxlength="4")
              +Param(ref="detectorId" title="Detector ID" type="number" min="0"
                @edit="$refs.detectorId.checkValidity(); edit.detectorId = $event"
                :value="detectorId" :inEdit="inEdit")
              +ParamList.col-12.col-sm-6.col-lg-4.col-xl-2(ref="fullScale" title="Full Scale [mV]"
                :value="fullScale" :inEdit="inEdit" :options="FullScaleValues"
                @edit="updateEditOffset(); edit.fullScale = $event")
              +ParamReadonly(ref="offset" title="Offset [mV]"  :value="offset"
                type="number" :max="OffsetLimits" :min="-OffsetLimits" :inEdit="inEdit" @edit="checkOffsetWarning(); edit.offset = $event")
              +Param(ref="lowerLimit" title="Lower Limit [mV]" type="number"
                :value="lowerLimit" :inEdit="inEdit"
                @edit="updateEditOffset(); edit.lowerLimit = $event")
              ParamList.col-12.col-sm-6.col-lg-4.col-xl-2(ref="impedance" title="Impedance [Ω]"
                @edit='edit.impedance = $event'
                :value="impedance" :inEdit="inEdit"
                :options="ImpedanceValues")

        Collapsible.x-zsp
          template(v-slot:header)
            .row.no-gutters
              BaseToggle.col-auto(:value='isZSP' :inEdit='inEdit'
                  @click.native.stop @edit='onZSPEdit')
              .col-auto #[strong Zero Suppression]
          .col-12
            .row.b-param-container(v-show='!inEdit || isZSPEdit')
              ParamList.col-12.col-sm-6.col-lg-4.col-xl-2(ref="thresholdSign"
                :value="thresholdSign" :inEdit="inEdit" @edit='edit.thresholdSign = $event'
                :options='[ { value: 1, text: "+" }, { value: 0, text: "-" } ]'
                title="Signal Leading Edge")
              +Param(ref="threshold" title="Threshold [mV]" :value="threshold" @edit='edit.threshold = $event' :inEdit="inEdit")
              +Param(ref="zsStart" title="∅ Delay [ns]" :value="zsStart" @edit='edit.zsStart = $event' :inEdit="inEdit")
              +Param(ref="preSamples" title="Pre Samples [S]" :value="preSamples" @edit='edit.preSamples = $event' :inEdit="inEdit")
              +Param(ref="postSamples" title="Post Samples [S]" :value="postSamples" @edit='edit.postSamples = $event' :inEdit="inEdit")
            .row.b-param-container(v-if='inEdit && !isZSPEdit')
              +ParamReadonly(title="Signal Leading Edge" :value='edit.thresholdSign ? "+" : "-"' :inEdit='inEdit')
              +ParamReadonly(title="Threshold [mV]" :value="edit.threshold" :inEdit="inEdit")
              +ParamReadonly(title="∅ Delay [ns]" :value="edit.zsStart" :inEdit="inEdit")
              +ParamReadonly(title="Pre Samples [S]" :value="edit.preSamples" :inEdit="inEdit")
              +ParamReadonly(title="Post Samples [S]" :value="edit.postSamples" :inEdit="inEdit")

        Collapsible.x-calib
          template(v-slot:header)
            strong Calibration
          template(v-slot:default='c')
            AnimBlock(anim="delay" :appear='false' mode='' :options='{ outDelay: 0.3 }')
              .col-12(v-if='c.isExpanded')
                ChannelCalibration(:card="card" :channel="channel" :inEdit='inEdit')
</template>
<script>
export { default } from './Channel.vue.js';
</script>
